# Python final project
Copyright © 2022 Kouhei Nozaki. All rights reserved.

# ライセンス
## ボール
- 以下のボールの表示、動き、コンストラクタ、は大澤文孝さんが作者の「いちばんやさしいPython入門教室」の221、222ページのコード引用しました。
-ライセンス: 不明
```python
class Ball:
    global r2, scene
    r2 = 16
    def __init__(self, x, y, dx, dy, color,r1, text,font):
        self.x = x
        self.y = y
        self.dx = dx
        self.dy = dy
        self.color = color
        self.r1 = r1
        self.text = text
        self.font = font
        self.exist = True
        self.id1 = None
        self.id2 = None

    def move1(self, canvas):
        if self.exist and scene == 0:
            canvas.delete(self.id1)
            canvas.delete(self.id2)
            self.x =self.x + self.dx
            self.y =self.y + self.dy
            self.id1 =canvas.create_oval(self.x - self.r1, self.y - self.r1, self.x + self.r1, self.y + self.r1, fill =self.color, width=1)
            self.id2 =canvas.create_text(self.x+self.r1 +10 ,self.y-self.r1-10 ,fill =self.color,text = self.text, font= self.font)
    def move2(self,canvas):
        l1 = [0,2,4,5]
        l2 = [0,-2,-4,-5]
        if self.x >= canvas.winfo_width():
            self.dx = random.choice(l2)
        elif self.x >= random.randint(0,1200):
            self.dx = random.choice(l2)
        elif self.x <= random.randint(0,1200):
            self.dx = random.choice(l1)
        if self.x <= 0:
            self.dx = random.choice(l1)
        elif self.y <= random.randint(0,700):
            self.dy = random.choice(l1)
        elif self.y >= random.randint(0,700):
            self.dy = random.choice(l2)
        if self.y >= canvas.winfo_height():
            self.dy = random.choice(l2)
        if self.y <= 0:
            self.dy = random.choice(l1)
```
以下のコードは「多浪Fランぼっち底辺大学生」さんが書いた「【Python】tkinterで図形を動かして接触判定を実装してみる」というホームページを参考にしました。
- 参照:[【Python】tkinterで図形を動かして接触判定を実装してみる
](https://www.frankdaigakusei.com/programming/touch-judge/)
```python
 def move2(self):
        global scene
        if scene == 0:
            canvas.delete("c2") 
            canvas.delete("c3")
            canvas.create_oval(self.x-r2, self.y-r2, self.x+r2, self.y+r2, fill="#F0F0F0", tag="c2")
            canvas.create_text(self.x+ r2 + r2/2 +10 ,self.y-r2-10 ,fill ="#F0F0F0",text = "関学",font=("Cambria",r2+ 5),tag = "c3")
            for ball in balls:
                dis = math.sqrt((self.x-ball.x)*(self.x-ball.x) + (self.y-ball.y)*(self.y-ball.y))
                if dis <= ball.r1 + r2 and ball.r1 < r2:
                    ball.exist = False
                    ball.destroy()
                    ball.strength()
                if dis <= ball.r1 + r2 and ball.r1 >= r2:
                    Poy.destroy(self)
                    scene = 1
```
### 参照元との変更点
- judgeという関数を呼び出す過程を省いてmove2内で計算を行っています。
- コンストラクタを使用しているためx2をself.xに変えています
- 色の検知は行わないのでそのためのコードは消去しています。
  
```pythhon
def gameclear():
    winflag = 0
    for ball in balls:
        if ball.exist ==False:
               winflag += 1
    if winflag == number_of_balls:
        canvas.create_text(550, 350, text="全ての大学を併合しました",fill="lime", font=("Cambria",50 )) 
    root.after(1000, gameclear)
```
下記のコード「ell」さんが書いた「【Python】Tkinterを使ってシューティングゲーム制作」というホームページで使われているコードの[def gameclear]以下10行の部分を引用しました。
- 参照:[【Python】Tkinterを使ってシューティングゲーム制作](https://qiita.com/ell/items/f0f74865c07710f1eab8)
- ライセンス: MITライセンス [ishikawa08/invader_game](https://github.com/ishikawa08/invader_game/blob/master/LICENSE)



```python
import tkinter as tk
import random
import math

from turtle import clear

from numpy import number
scene = 0
number_of_balls =15

class Ball:
    global r2, scene
    r2 = 16
    def __init__(self, x, y, dx, dy, color,r1, text,font):
        self.x = x
        self.y = y
        self.dx = dx
        self.dy = dy
        self.color = color
        self.r1 = r1
        self.text = text
        self.font = font
        self.exist = True
        self.id1 = None
        self.id2 = None

    def move1(self, canvas):
        if self.exist and scene == 0:
            canvas.delete(self.id1)
            canvas.delete(self.id2)
            self.x =self.x + self.dx
            self.y =self.y + self.dy
            self.id1 =canvas.create_oval(self.x - self.r1, self.y - self.r1, self.x + self.r1, self.y + self.r1, fill =self.color, width=1)
            self.id2 =canvas.create_text(self.x+self.r1 +10 ,self.y-self.r1-10 ,fill =self.color,text = self.text, font= self.font)
    def move2(self,canvas):
        l1 = [0,2,4,5]
        l2 = [0,-2,-4,-5]
        if self.x >= canvas.winfo_width():
            self.dx = random.choice(l2)
        elif self.x >= random.randint(0,1200):
            self.dx = random.choice(l2)
        elif self.x <= random.randint(0,1200):
            self.dx = random.choice(l1)
        if self.x <= 0:
            self.dx = random.choice(l1)
        elif self.y <= random.randint(0,700):
            self.dy = random.choice(l1)
        elif self.y >= random.randint(0,700):
            self.dy = random.choice(l2)
        if self.y >= canvas.winfo_height():
            self.dy = random.choice(l2)
        if self.y <= 0:
            self.dy = random.choice(l1)
        
    def destroy(self):
        canvas.delete(self.id1)
        canvas.delete(self.id2)
        self.x = 100000    
        self.y =1000000
    def strength(self):
        global r2,scene
        r2 = r2 + 3

    def destroy(self):
        canvas.delete(self.id1)
        canvas.delete(self.id2)
        self.x = 100000    
        self.y =1000000
       
class Poy:
    def __init__(self,x,y,color, text):
            self.x =x
            self.y =y
            self.color = color
            self.text = text
            self.id3 = None
            self.exist = True

    def move2(self):
        global scene
        if scene == 0:
            canvas.delete("c2") 
            canvas.delete("c3")
            canvas.create_oval(self.x-r2, self.y-r2, self.x+r2, self.y+r2, fill="#F0F0F0", tag="c2")
            canvas.create_text(self.x+ r2 + r2/2 +10 ,self.y-r2-10 ,fill ="#F0F0F0",text = "関学",font=("Cambria",r2+ 5),tag = "c3")
            for ball in balls:
                dis = math.sqrt((self.x-ball.x)*(self.x-ball.x) + (self.y-ball.y)*(self.y-ball.y))
                if dis <= ball.r1 + r2 and ball.r1 < r2:
                    ball.exist = False
                    ball.destroy()
                    ball.strength()
                if dis <= ball.r1 + r2 and ball.r1 >= r2:
                    Poy.destroy(self)
                    scene = 1
    def destroy(self):
        self.exist = False
        canvas.delete("c2")
        canvas.delete("c3")
        gameover()



def gameover():
    global scene
    canvas.create_text(550, 350, text="あなたの大学は併合されました\n Mastery for service が足りていません",fill="red", font=("Cambria",50))
    scene = 0
  
poy = Poy(None,None ,"#F0F0F0","関学")

def gameclear():
    winflag = 0
    for ball in balls:
        if ball.exist ==False:
               winflag += 1
    if winflag == number_of_balls:
        canvas.create_text(550, 350, text="全ての大学を併合しました",fill="lime", font=("Cambria",50 )) 
    root.after(1000, gameclear)

            
balls =[Ball(random.randint(100,1000), random.randint(100,600), random.randint(-5,5),random.randint(-5,5), "#220088",7, "摂南",font=("Cambria",12)),
        Ball(random.randint(100,900), random.randint(300,500), random.randint(-5,5),random.randint(-5,5), "pink",7,"桃山",font=("Cambria",12)),
        Ball(random.randint(300,1000), random.randint(300,700), random.randint(-5,5),random.randint(-5,5), "#220000",7,"追手門",font=("Cambria",12)),
        Ball(random.randint(480,950), random.randint(100,500), random.randint(-5,5),random.randint(-5,5), "#19FF00",7, "神戸学院",font=("Cambria",12)), 
        Ball(random.randint(300,1000), random.randint(100,500), random.randint(-5,5),random.randint(-5,5), "#004409",11,"京産",font=("Cambria",15)),
        Ball(random.randint(100,550), random.randint(50,600), random.randint(-5,5),random.randint(-5,5), "magenta",11, "近大",font=("Cambria",15)), 
        Ball(random.randint(200,1000), random.randint(100,600), random.randint(-5,5),random.randint(-5,5), "#FF5500",11,"甲南",font=("Cambria",15)),
        Ball(random.randint(100,1000), random.randint(100,500), random.randint(-5,5),random.randint(-5,5), "#000011",11,"龍谷", font=("Cambria",15)),
        Ball(random.randint(300,1000), random.randint(300,500), random.randint(-5,5),random.randint(-5,5), "blue",15,"関大",font=("Cambria",20)), 
        Ball(random.randint(300,750), random.randint(100,600), random.randint(-5,5),random.randint(-5,5), "purple",18,"同志社",font=("Cambria",20)),
        Ball(random.randint(100,550), random.randint(300,600), random.randint(-5,5),random.randint(-5,5), "orange",15, "立命館", font=("Cambria",20)), 
        Ball(random.randint(300,950), random.randint(50,500), random.randint(-5,5),random.randint(-5,5), "navy",30,"大阪公立",font=("Cambria",30)),
        Ball(random.randint(300,950), random.randint(50,500), random.randint(-5,5),random.randint(-5,5), "grey",40,"神戸",font=("Cambria",30)),
        Ball(random.randint(100,1000), random.randint(100,500), random.randint(-5,5),random.randint(-5,5), "#FF0000",48,"大阪",font=("Cambria",30)), 
        Ball(random.randint(100,950), random.randint(100,600), random.randint(-5,5),random.randint(-5,5), "black",55,"京都", font=("Cambria",30)),
      
          ]
root = tk.Tk()
root.geometry("1100x700")
canvas =tk.Canvas(root, width =8000,height =4000, bg="white")
canvas.place(x = 0, y = 0)
canvas.bind("<Motion>",Poy.move2)

def loop1():
        for b in balls:
            b.move1(canvas)
        root.after(10,loop1)
def loop2():
    for c in balls:
        c.move2(canvas)
    root.after(500,loop2)

root.after(10,loop1)
root.after(500,loop2)

gameclear()
root.mainloop()
```
# Copyright and License Information

This project is licensed under the terms of the MIT license.
